<?php
@include_once _MOBJ_MODULES_FOLDER_.'u5/lang/lng_'.$pers_set[lng].'.php';
@include_once _MOBJ_MODULES_FOLDER_.'u5/lang/lng_'.$HTTP_ACCEPT_LANGUAGE.'.php';
@include_once _MOBJ_MODULES_FOLDER_.'u5/lang/lng_en.php'; // Default language, if not found any other

$mobj->m_name[5] = 'U5 "Users"';
$mobj->m_ver[5] = '1.4';
$mobj->m_changes[5] = '';

// Main class of module U5
class U5 {
  function U5($cfg_name = '')
  {
    global $mobj;

    // Default
    $mobj->SQL = "select * from "._MOBJ_DB_TPREF_."u5_configuration where id=''";
    $R = $mobj->DB_db_query();
    $tmp = $mobj->DB_fetch_assoc($R);
    foreach ($tmp as $field=>$val) {
      if (trim($val) == '') eval('$this->'.$field.' = "";');
      if ($field == 'tmpl_user_row') $this->tmpl_user_row = $val;
      elseif (!empty($val) and !in_array($field, array('title','uid','gid_r','gid_w'))) eval('$this->'.$field.' = '.$val.';');
    }
    // Special if specified
    $mobj->SQL = "select * from "._MOBJ_DB_TPREF_."u5_configuration where id='$cfg_name'";
    $R = $mobj->DB_db_query();
    if ($mobj->DB_num_rows($R) > 0) {
      $tmp = $mobj->DB_fetch_assoc($R);
      foreach ($tmp as $field=>$val) {
        if ($val != '-1') {
          if (trim($val) == '') eval('$this->'.$field.' = "";');
          if ($field == 'tmpl_user_row') $this->tmpl_user_row = $val;
          elseif (!empty($val) and !in_array($field, array('title','uid','gid_r','gid_w'))) eval('$this->'.$field.' = '.$val.';');
        }
      }
    }
  }

  // Return list of users
  function u5get_users($page = 1, $chk_perm = '')
  {
    global $mobj, $pers_set;
    $this->HTML_users = '';
    if (!is_numeric($page)) $page = 1;

    // Checking of permission
    if ($chk_perm!='' and ($pers_set[ug]!='0'))
      $suf .= (empty($suf)?' where ':' and ')."(gid_$chk_perm='*'
        ".($pers_set[ug]==''?"":" or gid_$chk_perm like '%".$pers_set[ug]."%'")." or (uid!='' and uid='".$pers_set[id]."' and gid_$chk_perm not like '%-%'))";

    $mobj->SQL = "select * from "._MOBJ_DB_TPREF_."u5_users$suf order by ".$this->users_order;
    $Rpn = $mobj->DB_db_query();
    $this->lq_users_q = $mobj->DB_num_rows($Rpn);
    $mobj->SQL .= " limit ".(($page-1)*$this->users_on_page).",".$this->users_on_page;
    if ($R = $mobj->DB_db_query())
      for ($I=0;$I<$mobj->DB_num_rows($R);$I++) {
        $user_row = $mobj->DB_fetch_object($R);
        eval($this->tmpl_user_row);
        $this->HTML_users .= $this->user_row;
        if ($I < $mobj->DB_num_rows($R)-1) $this->HTML_users .= $this->users_div;
      }
  }

  // Addes a new user
  // Out: 0 if succesfully registered, 1 if login exists, 2 if E-mail exists,
  // 3 if one of the fields is empty, 4 if invalid E-mail, 5 if access denied
  // $allowed_groups - groups which can add users
  function u5add_user($login, $psw, $lng, $ug, $email, $check_email = FALSE, $allowed_groups = '0', $user_data = '')
  {
    global $mobj, $pers_set;
    $mobj->SQL = "select * from "._MOBJ_DB_TPREF_."u5_users where id='".$new_pers_set[id]."'";
    $R = $mobj->DB_db_query();
    if (!$mobj->check_authority($allowed_groups)) return array(5);

    $reg_res = array(0);
    // Checking
    if (empty($login) or empty($psw) or ($check_email and empty($email))) return array(3);
    if ($check_email and !validate_email($email)) return array(4);
    $mobj->SQL = "select id from "._MOBJ_DB_TPREF_."u5_users where login='$login'";
    if ($mobj->DB_num_rows($mobj->DB_db_query()) > 0) return array(1);
    if ($check_email) {
      $mobj->SQL = "select id from "._MOBJ_DB_TPREF_."u5_users where email='$email'";
      if ($mobj->DB_num_rows($mobj->DB_db_query()) > 0) return array(2);
    }
    // Registration
    if ($reg_res[0] == 0) {
      $user_id = uniqid('');
      $mobj->SQL = "insert into "._MOBJ_DB_TPREF_."u5_users (id, uid, gid_rm, gid_wm, login, psw, lng, ug, reg_date, p_email, host) values('$user_id', '".$pers_set[id]."','".$pers_set[gid_rm]."','".$pers_set[gid_wm]."', '$login', '".md5($psw)."', '$lng', '$ug', now(), '$email', '".Get_IP()."')";
      $mobj->DB_db_query();

      // Additional fields
      if (get_magic_quotes_gpc()) $tmp_quotes = TRUE;
      foreach ($user_data as $I=>$val) {
        if (!empty($suf)) $suf .= ',';
        if (!$tmp_quotes) $val = addslashes($val);
        $suf .= " $I='$val'";
      }
      $mobj->SQL = "update "._MOBJ_DB_TPREF_."u5_users set$suf where id='$user_id'";
      $R = $mobj->DB_db_query();

      $reg_res = array('0'=>'0', 'id'=>$user_id);
    } else $reg_res = array('0'=>$reg_res);
    return $reg_res;
  }

  // Updates a data of user
  // Out: 0 if succesfully updated, 1 if user not found,
  // 2 if current ID is not $new_pers_set[id], 3 if login is empty,
  // 4 if access denied, 5 if new login is already exists
  function u5update_user($new_pers_set, $cur_id = '', $check_cur_id = FALSE)
  {
    global $mobj, $pers_set;
    $mobj->SQL = "select * from "._MOBJ_DB_TPREF_."u5_users where id='".$new_pers_set[id]."'";
    $R = $mobj->DB_db_query();
    if (!$mobj->check_authority($mobj->DB_result($R,0,'gid_w'),$mobj->DB_result($R,0,'uid'))) return 4;

    $mobj->SQL = "select count(*) from "._MOBJ_DB_TPREF_."u5_users where login='".$new_pers_set[login]."' and id!='".$new_pers_set[id]."'";
    $R = $mobj->DB_db_query();
    if ($mobj->DB_result($R,0) > 0) return 5;

    if (empty($new_pers_set[login])) return 3;
    if ($check_cur_id and $new_pers_set[id]!=$cur_id) return 2;
    $mobj->SQL = "select id from "._MOBJ_DB_TPREF_."u5_users where id='".$new_pers_set[id]."'";
    if ($mobj->DB_num_rows($mobj->DB_db_query()) == 1) {
      if (get_magic_quotes_gpc()) $tmp_quotes = TRUE;
      foreach($new_pers_set as $I=>$val) {
        if ($I != 'psw') {
          if (!empty($suf)) $suf .= ', ';
          if (!$tmp_quotes) $new_pers_set[$I] = addslashes($new_pers_set[$I]);
          $suf .= " $I='".$new_pers_set[$I]."'";
        }
      }
      if (!empty($new_pers_set[psw])) $suf .= ", psw='".md5($new_pers_set[psw])."'"; // Only if setted new password
      $mobj->SQL = "update "._MOBJ_DB_TPREF_."u5_users set $suf where id='".$new_pers_set[id]."'";
      $mobj->DB_db_query();
      $upd_res = 0;
    } else $upd_res = 1;
    return $upd_res;
  }

  // Deletes an user
  // 0 if succesfully deleted, 1 if access denied, 2 if user found in linked modules
  function u5delete_user($id)
  {
    global $mobj, $pers_set;
    $mobj->SQL = "select * from "._MOBJ_DB_TPREF_."u5_users where id='$id'";
    $R = $mobj->DB_db_query();
    if (!$mobj->check_authority($mobj->DB_result($R,0,'gid_w'),$mobj->DB_result($R,0,'uid'))) return 1;

    if ($this->u5check_linked_modules($id)) return 2;

    $mobj->SQL = "delete from "._MOBJ_DB_TPREF_."u5_users where id='".$id."'";
    $mobj->DB_db_query();
    return 0;
  }

  // Return user data by login and password or null otherwise (used for authorization)
  function u5get_user_by_login($login, $password, $check_host = FALSE)
  {
    global $mobj;
    $pers_set = FALSE;
    $mobj->SQL = "select id from "._MOBJ_DB_TPREF_."u5_users where login='$login' and psw='".md5($password)."' and act='1'".($check_host?" and host='".Get_IP()."'":"");
    $R = $mobj->DB_db_query();
    if ($mobj->DB_num_rows($R) > 0) {
      $pers_set = $this->u5get_user_by_id($mobj->DB_result($R,0,'id'));
      $mobj->SQL = "update "._MOBJ_DB_TPREF_."u5_users set last_auth_date=now() where id='".$mobj->DB_result($R,0,'id')."'";
      $R = $mobj->DB_db_query();
    }
    return $pers_set;
  }

  // Return user data by id
  function u5get_user_by_id($user_id)
  {
    global $mobj;
    unset($pers_set);
    $mobj->SQL = "select * from "._MOBJ_DB_TPREF_."u5_users where id='$user_id'";
    $R = $mobj->DB_db_query();
    if ($mobj->DB_num_rows($R) == 1) $pers_set = $mobj->DB_fetch_array($R);
    return $pers_set;
  }

  // Checks presented or not specified user in linked modules
  // Out: TRUE if present, FALSE otherwise
  function u5check_linked_modules($id)
  {
    global $mobj;
    unset($pers_set);
    $mobj->SQL = "select count(*) from "._MOBJ_DB_TPREF_."u21_users where cid='$id' or mid='$id'";
    if ($mobj->DB_result($mobj->DB_db_query(),0) > 0) return TRUE;
    $mobj->SQL = "select count(*) from "._MOBJ_DB_TPREF_."u20_users where id='$id'";
    if ($mobj->DB_result($mobj->DB_db_query(),0) > 0) return TRUE;
    return FALSE;
  }

  // Generates new password and send by E-mail
  function u5remind_password($login, $email, $new_password = '')
  {
    global $mobj;

    if (empty($new_password)) $new_password = uniqid('');
    $mobj->SQL = "select id from "._MOBJ_DB_TPREF_."u5_users where login='$login' and p_email='$email'";
    $R = $mobj->DB_db_query();
    if ($mobj->DB_num_rows($R) == 0) return 1;

    $mobj->SQL = "update "._MOBJ_DB_TPREF_."u5_users set psw='".md5($new_password)."' where id='".$mobj->DB_result($R, 0)."'";
    $mobj->DB_db_query();

    $mail_mes = str_replace(array('[LOGIN]', '[PASSWORD]'),
      array($login, $new_password), $this->remind_psw_tmpl);
    $mail = new Mail_sender;
    $mail->from_addr = $mobj->email_support;
    $mail->from_name = _MOBJ_URL_;
    $mail->to = $email;
    $mail->subj = $this->remind_psw_subj;
    $mail->body_type = 'text/html';
    $mail->body = $mail_mes;
    $mail->priority = 3;
    $mail->send_mail();

    return 0;
  }
}
?>